//-----------------------------------------------------------------------------
//
//   cdtimer.cpp
//
//   Implementation of the class cdtimer (Countdown timer thread)
//
//    2004-2007 by Bernd-Ludwig Wenning
//
//-----------------------------------------------------------------------------
//
//  This file is part of RC4.
//
//    RC4 is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    RCM is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with RC4; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//-----------------------------------------------------------------------------

#include "cdtimer.h"

// Constructor
cdtimer::cdtimer(HANDLE rch, bool dtr, wxGauge* gauge, int up, int down){
    relc.hcom = rch;
    bdtr = dtr;
    wxg = gauge;
    countup = up;
    countdown = down;
}

// Countdown thread execution
void *cdtimer::Entry(){
    // count up
    wxg->SetRange(countup);
    for (int i=1; i<(countup+1); i++){
        Sleep(1000);
        wxg->SetValue(i);
    }
    relc.SwitchOn(bdtr);
    // count down
    wxg->SetRange(countdown-countup);
    wxg->SetValue(countdown-countup);
    for (int i=1; i<(countdown-countup+1); i++){
        Sleep(1000);
        wxg->SetValue(countdown-countup-i);
    }
    relc.SwitchOff(bdtr);
    
    relc.hcom = NULL;
    wxg = NULL;
    return NULL;
}
