//-----------------------------------------------------------------------------
//
//   countdownDlg.cpp
//
//   Implementation of the class countdownDlg (Countdown Dialog Frame)
//
//    2007 by Bernd-Ludwig Wenning
//
//-----------------------------------------------------------------------------
//
//  This file is part of RC4.
//
//    RC4 is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    RCM is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with RC4; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//-----------------------------------------------------------------------------

#include "countdownDlg.h"
#include "cdtimer.h"

//Do not add custom headers.
//wx-dvcpp designer will remove them
////Header Include Start
////Header Include End



//----------------------------------------------------------------------------
// countdownDlg
//----------------------------------------------------------------------------
     //Add Custom Events only in the appropriate Block.
    // Code added in  other places will be removed by wx-dvcpp 
    ////Event Table Start
BEGIN_EVENT_TABLE(countdownDlg,wxDialog)
	////Manual Code Start
	////Manual Code End
	
	EVT_CLOSE(countdownDlg::countdownDlgClose)
	EVT_BUTTON(ID_WXBUTTON1,countdownDlg::WxButton1Click)
END_EVENT_TABLE()
    ////Event Table End


// Constructor
countdownDlg::countdownDlg( wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style )
    : wxDialog( parent, id, title, position, size, style)
{
    CreateGUIControls();
}

// Destructor
countdownDlg::~countdownDlg() {} 

// GUI creation
void countdownDlg::CreateGUIControls(void)
{
    //Do not add custom Code here
    //wx-devcpp designer will remove them.
    //Add the custom code before or after the Blocks
    ////GUI Items Creation Start

	this->SetSize(8,8,183,135);
	this->SetTitle(_("Configure Countdown"));
	this->Center();
	this->SetIcon(wxNullIcon);
	

	WxButton1 =  new wxButton(this, ID_WXBUTTON1, _("Start Countdown!") , wxPoint(0,80),wxSize(174,25) );

	WxStaticText2 =  new wxStaticText(this, ID_WXSTATICTEXT2 ,_("switch off in ... seconds") ,wxPoint(8,48),wxSize(115,17)  );

	WxStaticText1 =  new wxStaticText(this, ID_WXSTATICTEXT1 ,_("switch on in ... seconds") ,wxPoint(8,16),wxSize(115,17)  );

	WxEdit2 =  new wxTextCtrl(this, ID_WXEDIT2, _("") , wxPoint(135,47),wxSize(35,21) );
	WxEdit2->SetMaxLength(0);

	WxEdit1 =  new wxTextCtrl(this, ID_WXEDIT1, _("") , wxPoint(135,15),wxSize(35,21) );
	WxEdit1->SetMaxLength(0);
    ////GUI Items Creation End
}

// Close the countdown dialog
void countdownDlg::countdownDlgClose(wxCloseEvent& event)
{
    Destroy();
}
 

/*
 * WxButton1Click
 * Initiate and start the countdown timer
 */
void countdownDlg::WxButton1Click(wxCommandEvent& event)
{
    int up = atoi(WxEdit1->GetValue().c_str());
    int down = atoi(WxEdit2->GetValue().c_str());
	cdtimer* timer = new cdtimer(rch, dtr, gauge, up, down);
	timer->Create();
	timer->Run();
	gauge = NULL;
	rch = NULL;
	Destroy();
}

/*
 * Countdown Parameters
 */
void countdownDlg::SetCountdownParams(HANDLE hnd, bool bdtr, wxGauge* wxg)
{
    rch = hnd;
    dtr = bdtr;
    gauge = wxg;
}
