//-----------------------------------------------------------------------------
//
//   rc4Frame.cpp
//
//   Implementation of the class rc4Frame (Application Main Frame)
//
//    2007 by Bernd-Ludwig Wenning
//
//-----------------------------------------------------------------------------
//
//  This file is part of RC4.
//
//    RC4 is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    RCM is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with RC4; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//-----------------------------------------------------------------------------

#include "rc4Frame.h"
//Do not add custom headers.
//wx-dvcpp designer will remove them
////Header Include Start
#include "rc4Frame_XPM.xpm"
////Header Include End

#include "tasktimerDlg.h"
#include "countdownDlg.h"

RelayControl com1("COM1");
RelayControl com2("COM2");
RelayControl com3("COM3");
RelayControl com4("COM4");

//----------------------------------------------------------------------------
// rc4Frame
//----------------------------------------------------------------------------
   //Add Custom Events only in the appropriate Block.
   // Code added in  other places will be removed by wx-dvcpp 
  ////Event Table Start
BEGIN_EVENT_TABLE(rc4Frame,wxFrame)
	////Manual Code Start
	////Manual Code End
	
	//EVT_CLOSE(rc4Frame::rc4FrameClose)
	EVT_BUTTON(ID_WXBUTTON56,rc4Frame::rc4FrameClose)
	EVT_BUTTON(ID_WXBUTTON55,rc4Frame::OpenManual)
	EVT_BUTTON(ID_WXBUTTON54,rc4Frame::ConfigureTT)
	EVT_BUTTON(ID_WXBUTTON53,rc4Frame::ConfigureTT)
	EVT_BUTTON(ID_WXBUTTON52,rc4Frame::ConfigureCountdown)
	EVT_BUTTON(ID_WXBUTTON51,rc4Frame::ConfigureCountdown)
	EVT_BUTTON(ID_WXBUTTON50,rc4Frame::OscillatorOff)
	EVT_BUTTON(ID_WXBUTTON49,rc4Frame::OscillatorOn)
	EVT_BUTTON(ID_WXBUTTON48,rc4Frame::OscillatorOff)
	EVT_BUTTON(ID_WXBUTTON47,rc4Frame::OscillatorOn)
	EVT_BUTTON(ID_WXBUTTON46,rc4Frame::ManualRelayOff)
	EVT_BUTTON(ID_WXBUTTON45,rc4Frame::ManualRelayOn)
	EVT_BUTTON(ID_WXBUTTON44,rc4Frame::ManualRelayOff)
	EVT_BUTTON(ID_WXBUTTON43,rc4Frame::ManualRelayOn)
	EVT_CHECKBOX(ID_WXCHECKBOX8,rc4Frame::ActivateTT)
	EVT_CHECKBOX(ID_WXCHECKBOX7,rc4Frame::ActivateTT)
	EVT_BUTTON(ID_WXBUTTON42,rc4Frame::rc4FrameClose)
	EVT_BUTTON(ID_WXBUTTON41,rc4Frame::OpenManual)
	EVT_BUTTON(ID_WXBUTTON40,rc4Frame::ConfigureTT)
	EVT_BUTTON(ID_WXBUTTON39,rc4Frame::ConfigureTT)
	EVT_BUTTON(ID_WXBUTTON38,rc4Frame::ConfigureCountdown)
	EVT_BUTTON(ID_WXBUTTON37,rc4Frame::ConfigureCountdown)
	EVT_BUTTON(ID_WXBUTTON36,rc4Frame::OscillatorOff)
	EVT_BUTTON(ID_WXBUTTON35,rc4Frame::OscillatorOn)
	EVT_BUTTON(ID_WXBUTTON34,rc4Frame::OscillatorOff)
	EVT_BUTTON(ID_WXBUTTON33,rc4Frame::OscillatorOn)
	EVT_BUTTON(ID_WXBUTTON32,rc4Frame::ManualRelayOff)
	EVT_BUTTON(ID_WXBUTTON31,rc4Frame::ManualRelayOn)
	EVT_BUTTON(ID_WXBUTTON30,rc4Frame::ManualRelayOff)
	EVT_BUTTON(ID_WXBUTTON29,rc4Frame::ManualRelayOn)
	EVT_CHECKBOX(ID_WXCHECKBOX6,rc4Frame::ActivateTT)
	EVT_CHECKBOX(ID_WXCHECKBOX5,rc4Frame::ActivateTT)
	EVT_BUTTON(ID_WXBUTTON28,rc4Frame::rc4FrameClose)
	EVT_BUTTON(ID_WXBUTTON27,rc4Frame::OpenManual)
	EVT_BUTTON(ID_WXBUTTON26,rc4Frame::ConfigureTT)
	EVT_BUTTON(ID_WXBUTTON25,rc4Frame::ConfigureTT)
	EVT_BUTTON(ID_WXBUTTON24,rc4Frame::ConfigureCountdown)
	EVT_BUTTON(ID_WXBUTTON23,rc4Frame::ConfigureCountdown)
	EVT_BUTTON(ID_WXBUTTON22,rc4Frame::OscillatorOff)
	EVT_BUTTON(ID_WXBUTTON21,rc4Frame::OscillatorOn)
	EVT_BUTTON(ID_WXBUTTON20,rc4Frame::OscillatorOff)
	EVT_BUTTON(ID_WXBUTTON19,rc4Frame::OscillatorOn)
	EVT_BUTTON(ID_WXBUTTON18,rc4Frame::ManualRelayOff)
	EVT_BUTTON(ID_WXBUTTON17,rc4Frame::ManualRelayOn)
	EVT_BUTTON(ID_WXBUTTON16,rc4Frame::ManualRelayOff)
	EVT_BUTTON(ID_WXBUTTON15,rc4Frame::ManualRelayOn)
	EVT_CHECKBOX(ID_WXCHECKBOX4,rc4Frame::ActivateTT)
	EVT_CHECKBOX(ID_WXCHECKBOX3,rc4Frame::ActivateTT)
	EVT_BUTTON(ID_WXBUTTON14,rc4Frame::rc4FrameClose)
	EVT_BUTTON(ID_WXBUTTON13,rc4Frame::OpenManual)
	EVT_CHECKBOX(ID_WXCHECKBOX2,rc4Frame::ActivateTT)
	EVT_CHECKBOX(ID_WXCHECKBOX1,rc4Frame::ActivateTT)
	EVT_BUTTON(ID_WXBUTTON12,rc4Frame::ConfigureTT)
	EVT_BUTTON(ID_WXBUTTON11,rc4Frame::ConfigureTT)
	EVT_BUTTON(ID_WXBUTTON10,rc4Frame::ConfigureCountdown)
	EVT_BUTTON(ID_WXBUTTON9,rc4Frame::ConfigureCountdown)
	EVT_BUTTON(ID_WXBUTTON8,rc4Frame::OscillatorOff)
	EVT_BUTTON(ID_WXBUTTON7,rc4Frame::OscillatorOn)
	EVT_BUTTON(ID_WXBUTTON6,rc4Frame::OscillatorOff)
	EVT_BUTTON(ID_WXBUTTON5,rc4Frame::OscillatorOn)
	EVT_BUTTON(ID_WXBUTTON4,rc4Frame::ManualRelayOff)
	EVT_BUTTON(ID_WXBUTTON3,rc4Frame::ManualRelayOn)
	EVT_BUTTON(ID_WXBUTTON2,rc4Frame::ManualRelayOff)
	EVT_BUTTON(ID_WXBUTTON1,rc4Frame::ManualRelayOn)
END_EVENT_TABLE()
  ////Event Table End



rc4Frame::rc4Frame( wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style )
    : wxFrame( parent, id, title, position, size, style)
{
    CreateGUIControls();
}

rc4Frame::~rc4Frame() {} 

void rc4Frame::CreateGUIControls(void)
{
    //Do not add custom Code here
    //wx-devcpp designer will remove them.
    //Add the custom code before or after the Blocks
    ////GUI Items Creation Start

	WxNotebook1 =  new wxNotebook(this, ID_WXNOTEBOOK1, wxPoint(0,0),wxSize(312,355) );
	WxNotebook1->SetForegroundColour(*wxLIGHT_GREY);
	WxNotebook1->SetBackgroundColour(*wxLIGHT_GREY);

	WxNoteBookPage1 =  new wxPanel(WxNotebook1, ID_WXNOTEBOOKPAGE1,wxPoint(4,24),wxSize(304,327) );
	WxNoteBookPage1->SetBackgroundColour(*wxLIGHT_GREY);
	WxNotebook1->AddPage(WxNoteBookPage1,_("COM 1"));

	WxButton1 =  new wxButton(WxNoteBookPage1, ID_WXBUTTON1, _("On") , wxPoint(0,32),wxSize(75,25) );

	WxButton2 =  new wxButton(WxNoteBookPage1, ID_WXBUTTON2, _("Off") , wxPoint(75,32),wxSize(75,25) );

	WxButton3 =  new wxButton(WxNoteBookPage1, ID_WXBUTTON3, _("On") , wxPoint(154,32),wxSize(75,25) );

	WxButton4 =  new wxButton(WxNoteBookPage1, ID_WXBUTTON4, _("Off") , wxPoint(229,32),wxSize(75,25) );

	WxButton5 =  new wxButton(WxNoteBookPage1, ID_WXBUTTON5, _("Oscillator On") , wxPoint(0,74),wxSize(75,25) );

	WxButton6 =  new wxButton(WxNoteBookPage1, ID_WXBUTTON6, _("Oscillator Off") , wxPoint(75,74),wxSize(75,25) );

	WxButton7 =  new wxButton(WxNoteBookPage1, ID_WXBUTTON7, _("Oscillator On") , wxPoint(154,74),wxSize(75,25) );

	WxButton8 =  new wxButton(WxNoteBookPage1, ID_WXBUTTON8, _("Oscillator Off") , wxPoint(229,74),wxSize(75,25) );

	WxSlider1 =  new wxSlider(WxNoteBookPage1, ID_WXSLIDER1,1,1,30,wxPoint(0,100),wxSize(150,45)  , wxSL_AUTOTICKS | wxSL_LABELS | wxSL_TOP |  wxSL_HORIZONTAL);
	WxSlider1->SetRange(1,30);
	WxSlider1->SetValue(1);

	WxSlider2 =  new wxSlider(WxNoteBookPage1, ID_WXSLIDER2,1,1,30,wxPoint(154,100),wxSize(150,45)  , wxSL_AUTOTICKS | wxSL_LABELS | wxSL_TOP |  wxSL_HORIZONTAL);
	WxSlider2->SetRange(1,30);
	WxSlider2->SetValue(1);

	WxButton9 =  new wxButton(WxNoteBookPage1, ID_WXBUTTON9, _("Configure Countdown") , wxPoint(0,156),wxSize(150,25) );

	WxButton10 =  new wxButton(WxNoteBookPage1, ID_WXBUTTON10, _("Configure Countdown") , wxPoint(154,156),wxSize(150,25) );

	WxButton11 =  new wxButton(WxNoteBookPage1, ID_WXBUTTON11, _("Configure Timer") , wxPoint(0,220),wxSize(150,25) );

	WxButton12 =  new wxButton(WxNoteBookPage1, ID_WXBUTTON12, _("Configure Timer") , wxPoint(154,220),wxSize(150,25) );

	WxGauge1 =  new wxGauge(WxNoteBookPage1, ID_WXGAUGE1,100 ,wxPoint(0,185),wxSize(150,16)  );
	WxGauge1->SetRange(100);
	WxGauge1->SetValue(0);

	WxGauge2 =  new wxGauge(WxNoteBookPage1, ID_WXGAUGE2,100 ,wxPoint(154,185),wxSize(150,16)  );
	WxGauge2->SetRange(100);
	WxGauge2->SetValue(0);

	WxCheckBox1 =  new wxCheckBox(WxNoteBookPage1, ID_WXCHECKBOX1, _("Activate Timer") , wxPoint(23,247),wxSize(97,17) );
	WxCheckBox1->Enable(false);
	WxCheckBox1->SetForegroundColour(wxColour(*wxBLACK));

	WxCheckBox2 =  new wxCheckBox(WxNoteBookPage1, ID_WXCHECKBOX2, _("Activate Timer") , wxPoint(178,247),wxSize(97,17) );
	WxCheckBox2->Enable(false);
	WxCheckBox2->SetForegroundColour(wxColour(*wxBLACK));

	WxStaticText1 =  new wxStaticText(WxNoteBookPage1, ID_WXSTATICTEXT1 ,_("DTR") ,wxPoint(63,7),wxSize(27,17)  );
	WxStaticText1->SetForegroundColour(wxColour(*wxBLACK));

	WxStaticText2 =  new wxStaticText(WxNoteBookPage1, ID_WXSTATICTEXT2 ,_("RTS") ,wxPoint(218,7),wxSize(26,17)  );
	WxStaticText2->SetForegroundColour(wxColour(*wxBLACK));

	WxButton13 =  new wxButton(WxNoteBookPage1, ID_WXBUTTON13, _("Open Manual") , wxPoint(3,300),wxSize(75,25) );

	WxButton14 =  new wxButton(WxNoteBookPage1, ID_WXBUTTON14, _("Exit") , wxPoint(226,301),wxSize(75,25) );

	WxNoteBookPage2 =  new wxPanel(WxNotebook1, ID_WXNOTEBOOKPAGE2,wxPoint(4,24),wxSize(304,327) );
	WxNoteBookPage2->SetBackgroundColour(*wxLIGHT_GREY);
	WxNotebook1->AddPage(WxNoteBookPage2,_("COM 2"));

	WxStaticText3 =  new wxStaticText(WxNoteBookPage2, ID_WXSTATICTEXT3 ,_("DTR") ,wxPoint(63,7),wxSize(27,17)  );
	WxStaticText3->SetForegroundColour(wxColour(*wxBLACK));

	WxStaticText4 =  new wxStaticText(WxNoteBookPage2, ID_WXSTATICTEXT4 ,_("RTS") ,wxPoint(218,7),wxSize(26,17)  );
	WxStaticText4->SetForegroundColour(wxColour(*wxBLACK));

	WxSlider3 =  new wxSlider(WxNoteBookPage2, ID_WXSLIDER3,1,1,30,wxPoint(0,100),wxSize(150,45)  , wxSL_AUTOTICKS | wxSL_LABELS | wxSL_TOP |  wxSL_HORIZONTAL);
	WxSlider3->SetRange(1,30);
	WxSlider3->SetValue(1);

	WxSlider4 =  new wxSlider(WxNoteBookPage2, ID_WXSLIDER4,1,1,30,wxPoint(154,100),wxSize(150,45)  , wxSL_AUTOTICKS | wxSL_LABELS | wxSL_TOP |  wxSL_HORIZONTAL);
	WxSlider4->SetRange(1,30);
	WxSlider4->SetValue(1);

	WxGauge3 =  new wxGauge(WxNoteBookPage2, ID_WXGAUGE3,100 ,wxPoint(0,185),wxSize(150,16)  );
	WxGauge3->SetRange(100);
	WxGauge3->SetValue(0);

	WxGauge4 =  new wxGauge(WxNoteBookPage2, ID_WXGAUGE4,100 ,wxPoint(154,185),wxSize(150,16)  );
	WxGauge4->SetRange(100);
	WxGauge4->SetValue(0);

	WxCheckBox3 =  new wxCheckBox(WxNoteBookPage2, ID_WXCHECKBOX3, _("Activate Timer") , wxPoint(23,247),wxSize(97,17) );
	WxCheckBox3->Enable(false);
	WxCheckBox3->SetForegroundColour(wxColour(*wxBLACK));

	WxCheckBox4 =  new wxCheckBox(WxNoteBookPage2, ID_WXCHECKBOX4, _("Activate Timer") , wxPoint(178,247),wxSize(97,17) );
	WxCheckBox4->Enable(false);
	WxCheckBox4->SetForegroundColour(wxColour(*wxBLACK));

	WxButton15 =  new wxButton(WxNoteBookPage2, ID_WXBUTTON15, _("On") , wxPoint(0,32),wxSize(75,25) );

	WxButton16 =  new wxButton(WxNoteBookPage2, ID_WXBUTTON16, _("Off") , wxPoint(75,32),wxSize(75,25) );

	WxButton17 =  new wxButton(WxNoteBookPage2, ID_WXBUTTON17, _("On") , wxPoint(154,32),wxSize(75,25) );

	WxButton18 =  new wxButton(WxNoteBookPage2, ID_WXBUTTON18, _("Off") , wxPoint(229,32),wxSize(75,25) );

	WxButton19 =  new wxButton(WxNoteBookPage2, ID_WXBUTTON19, _("Oscillator On") , wxPoint(0,74),wxSize(75,25) );

	WxButton20 =  new wxButton(WxNoteBookPage2, ID_WXBUTTON20, _("Oscillator Off") , wxPoint(75,74),wxSize(75,25) );

	WxButton21 =  new wxButton(WxNoteBookPage2, ID_WXBUTTON21, _("Oscillator On") , wxPoint(154,74),wxSize(75,25) );

	WxButton22 =  new wxButton(WxNoteBookPage2, ID_WXBUTTON22, _("Oscillator Off") , wxPoint(229,74),wxSize(75,25) );

	WxButton23 =  new wxButton(WxNoteBookPage2, ID_WXBUTTON23, _("Configure Countdown") , wxPoint(0,156),wxSize(150,25) );

	WxButton24 =  new wxButton(WxNoteBookPage2, ID_WXBUTTON24, _("Configure Countdown") , wxPoint(154,156),wxSize(150,25) );

	WxButton25 =  new wxButton(WxNoteBookPage2, ID_WXBUTTON25, _("Configure Timer") , wxPoint(0,220),wxSize(150,25) );

	WxButton26 =  new wxButton(WxNoteBookPage2, ID_WXBUTTON26, _("Configure Timer") , wxPoint(154,220),wxSize(150,25) );

	WxButton27 =  new wxButton(WxNoteBookPage2, ID_WXBUTTON27, _("Open Manual") , wxPoint(3,300),wxSize(75,25) );

	WxButton28 =  new wxButton(WxNoteBookPage2, ID_WXBUTTON28, _("Exit") , wxPoint(226,301),wxSize(75,25) );

	WxNoteBookPage3 =  new wxPanel(WxNotebook1, ID_WXNOTEBOOKPAGE3,wxPoint(4,24),wxSize(304,327) );
	WxNoteBookPage3->SetBackgroundColour(*wxLIGHT_GREY);
	WxNotebook1->AddPage(WxNoteBookPage3,_("COM 3"));

	WxStaticText5 =  new wxStaticText(WxNoteBookPage3, ID_WXSTATICTEXT5 ,_("DTR") ,wxPoint(63,7),wxSize(27,17)  );
	WxStaticText5->SetForegroundColour(wxColour(*wxBLACK));

	WxStaticText6 =  new wxStaticText(WxNoteBookPage3, ID_WXSTATICTEXT6 ,_("RTS") ,wxPoint(218,7),wxSize(26,17)  );
	WxStaticText6->SetForegroundColour(wxColour(*wxBLACK));

	WxSlider5 =  new wxSlider(WxNoteBookPage3, ID_WXSLIDER5,1,1,30,wxPoint(0,100),wxSize(150,45)  , wxSL_AUTOTICKS | wxSL_LABELS | wxSL_TOP |  wxSL_HORIZONTAL);
	WxSlider5->SetRange(1,30);
	WxSlider5->SetValue(1);

	WxSlider6 =  new wxSlider(WxNoteBookPage3, ID_WXSLIDER6,1,1,30,wxPoint(154,100),wxSize(150,45)  , wxSL_AUTOTICKS | wxSL_LABELS | wxSL_TOP |  wxSL_HORIZONTAL);
	WxSlider6->SetRange(1,30);
	WxSlider6->SetValue(1);

	WxGauge5 =  new wxGauge(WxNoteBookPage3, ID_WXGAUGE5,100 ,wxPoint(0,185),wxSize(150,16)  );
	WxGauge5->SetRange(100);
	WxGauge5->SetValue(0);

	WxGauge6 =  new wxGauge(WxNoteBookPage3, ID_WXGAUGE6,100 ,wxPoint(154,185),wxSize(150,16)  );
	WxGauge6->SetRange(100);
	WxGauge6->SetValue(0);

	WxCheckBox5 =  new wxCheckBox(WxNoteBookPage3, ID_WXCHECKBOX5, _("Activate Timer") , wxPoint(23,247),wxSize(97,17) );
	WxCheckBox5->Enable(false);
	WxCheckBox5->SetForegroundColour(wxColour(*wxBLACK));

	WxCheckBox6 =  new wxCheckBox(WxNoteBookPage3, ID_WXCHECKBOX6, _("Activate Timer") , wxPoint(178,247),wxSize(97,17) );
	WxCheckBox6->Enable(false);
	WxCheckBox6->SetForegroundColour(wxColour(*wxBLACK));

	WxButton29 =  new wxButton(WxNoteBookPage3, ID_WXBUTTON29, _("On") , wxPoint(0,32),wxSize(75,25) );

	WxButton30 =  new wxButton(WxNoteBookPage3, ID_WXBUTTON30, _("Off") , wxPoint(75,32),wxSize(75,25) );

	WxButton31 =  new wxButton(WxNoteBookPage3, ID_WXBUTTON31, _("On") , wxPoint(154,32),wxSize(75,25) );

	WxButton32 =  new wxButton(WxNoteBookPage3, ID_WXBUTTON32, _("Off") , wxPoint(229,32),wxSize(75,25) );

	WxButton33 =  new wxButton(WxNoteBookPage3, ID_WXBUTTON33, _("Oscillator On") , wxPoint(0,74),wxSize(75,25) );

	WxButton34 =  new wxButton(WxNoteBookPage3, ID_WXBUTTON34, _("Oscillator Off") , wxPoint(75,74),wxSize(75,25) );

	WxButton35 =  new wxButton(WxNoteBookPage3, ID_WXBUTTON35, _("Oscillator On") , wxPoint(154,74),wxSize(75,25) );

	WxButton36 =  new wxButton(WxNoteBookPage3, ID_WXBUTTON36, _("Oscillator Off") , wxPoint(229,74),wxSize(75,25) );

	WxButton37 =  new wxButton(WxNoteBookPage3, ID_WXBUTTON37, _("Configure Countdown") , wxPoint(0,156),wxSize(150,25) );

	WxButton38 =  new wxButton(WxNoteBookPage3, ID_WXBUTTON38, _("Configure Countdown") , wxPoint(154,156),wxSize(150,25) );

	WxButton39 =  new wxButton(WxNoteBookPage3, ID_WXBUTTON39, _("Configure Timer") , wxPoint(0,220),wxSize(150,25) );

	WxButton40 =  new wxButton(WxNoteBookPage3, ID_WXBUTTON40, _("Configure Timer") , wxPoint(154,220),wxSize(150,25) );

	WxButton41 =  new wxButton(WxNoteBookPage3, ID_WXBUTTON41, _("Open Manual") , wxPoint(3,300),wxSize(75,25) );

	WxButton42 =  new wxButton(WxNoteBookPage3, ID_WXBUTTON42, _("Exit") , wxPoint(226,301),wxSize(75,25) );

	WxNoteBookPage4 =  new wxPanel(WxNotebook1, ID_WXNOTEBOOKPAGE4,wxPoint(4,24),wxSize(304,327) );
	WxNoteBookPage4->SetBackgroundColour(*wxLIGHT_GREY);
	WxNotebook1->AddPage(WxNoteBookPage4,_("COM 4"));

	WxStaticText7 =  new wxStaticText(WxNoteBookPage4, ID_WXSTATICTEXT7 ,_("DTR") ,wxPoint(63,7),wxSize(27,17)  );
	WxStaticText7->SetForegroundColour(wxColour(*wxBLACK));

	WxStaticText8 =  new wxStaticText(WxNoteBookPage4, ID_WXSTATICTEXT8 ,_("RTS") ,wxPoint(218,7),wxSize(26,17)  );
	WxStaticText8->SetForegroundColour(wxColour(*wxBLACK));

	WxSlider7 =  new wxSlider(WxNoteBookPage4, ID_WXSLIDER7,1,1,30,wxPoint(0,100),wxSize(150,45)  , wxSL_AUTOTICKS | wxSL_LABELS | wxSL_TOP |  wxSL_HORIZONTAL);
	WxSlider7->SetRange(1,30);
	WxSlider7->SetValue(1);

	WxSlider8 =  new wxSlider(WxNoteBookPage4, ID_WXSLIDER8,1,1,30,wxPoint(154,100),wxSize(150,45)  , wxSL_AUTOTICKS | wxSL_LABELS | wxSL_TOP |  wxSL_HORIZONTAL);
	WxSlider8->SetRange(1,30);
	WxSlider8->SetValue(1);

	WxGauge7 =  new wxGauge(WxNoteBookPage4, ID_WXGAUGE7,100 ,wxPoint(0,185),wxSize(150,16)  );
	WxGauge7->SetRange(100);
	WxGauge7->SetValue(0);

	WxGauge8 =  new wxGauge(WxNoteBookPage4, ID_WXGAUGE8,100 ,wxPoint(154,185),wxSize(150,16)  );
	WxGauge8->SetRange(100);
	WxGauge8->SetValue(0);

	WxCheckBox7 =  new wxCheckBox(WxNoteBookPage4, ID_WXCHECKBOX7, _("Activate Timer") , wxPoint(23,246),wxSize(97,17) );
	WxCheckBox7->Enable(false);
	WxCheckBox7->SetForegroundColour(wxColour(*wxBLACK));

	WxCheckBox8 =  new wxCheckBox(WxNoteBookPage4, ID_WXCHECKBOX8, _("Activate Timer") , wxPoint(178,247),wxSize(97,17) );
	WxCheckBox8->Enable(false);
	WxCheckBox8->SetForegroundColour(wxColour(*wxBLACK));

	WxButton43 =  new wxButton(WxNoteBookPage4, ID_WXBUTTON43, _("On") , wxPoint(0,32),wxSize(75,25) );

	WxButton44 =  new wxButton(WxNoteBookPage4, ID_WXBUTTON44, _("Off") , wxPoint(75,32),wxSize(75,25) );

	WxButton45 =  new wxButton(WxNoteBookPage4, ID_WXBUTTON45, _("On") , wxPoint(154,32),wxSize(75,25) );

	WxButton46 =  new wxButton(WxNoteBookPage4, ID_WXBUTTON46, _("Off") , wxPoint(229,32),wxSize(75,25) );

	WxButton47 =  new wxButton(WxNoteBookPage4, ID_WXBUTTON47, _("Oscillator On") , wxPoint(0,74),wxSize(75,25) );

	WxButton48 =  new wxButton(WxNoteBookPage4, ID_WXBUTTON48, _("Oscillator Off") , wxPoint(75,74),wxSize(75,25) );

	WxButton49 =  new wxButton(WxNoteBookPage4, ID_WXBUTTON49, _("Oscillator On") , wxPoint(154,74),wxSize(75,25) );

	WxButton50 =  new wxButton(WxNoteBookPage4, ID_WXBUTTON50, _("Oscillator Off") , wxPoint(229,74),wxSize(75,25) );

	WxButton51 =  new wxButton(WxNoteBookPage4, ID_WXBUTTON51, _("Configure Countdown") , wxPoint(0,156),wxSize(150,25) );

	WxButton52 =  new wxButton(WxNoteBookPage4, ID_WXBUTTON52, _("Configure Countdown") , wxPoint(154,156),wxSize(150,25) );

	WxButton53 =  new wxButton(WxNoteBookPage4, ID_WXBUTTON53, _("Configure Timer") , wxPoint(0,220),wxSize(150,25) );

	WxButton54 =  new wxButton(WxNoteBookPage4, ID_WXBUTTON54, _("Configure Timer") , wxPoint(154,220),wxSize(150,25) );

	WxButton55 =  new wxButton(WxNoteBookPage4, ID_WXBUTTON55, _("Open Manual") , wxPoint(3,300),wxSize(75,25) );

	WxButton56 =  new wxButton(WxNoteBookPage4, ID_WXBUTTON56, _("Exit") , wxPoint(226,301),wxSize(75,25) );

	this->SetSize(8,8,320,382);
	this->SetTitle(_("RelayControl 4.0"));
	this->Center();
	wxIcon rc4Frame_ICON (rc4Frame_XPM);
	this->SetIcon(rc4Frame_XPM);
	
    ////GUI Items Creation End

    if (com4.hcom==INVALID_HANDLE_VALUE)
    {
       WxNotebook1->DeletePage(3);
    }
    if (com3.hcom==INVALID_HANDLE_VALUE)
    {
       WxNotebook1->DeletePage(2);
    }
    if (com2.hcom==INVALID_HANDLE_VALUE)
    {
       WxNotebook1->DeletePage(1);
    }
    if (com1.hcom==INVALID_HANDLE_VALUE)
    {
       WxNotebook1->DeletePage(0);
    }
}

/*
 * rc4FrameClose
 * Close the program
 */
void rc4Frame::rc4FrameClose(wxCommandEvent& event)
{
    Destroy();
}
 

/*
 * ManualRelayOn
 * Function for the "On" buttons
 * Correct port and pin are identified through the event ID
 */
void rc4Frame::ManualRelayOn(wxCommandEvent& event)
{
    bool dtr = isDtr(event.GetId());
    RelayControl* com = getRC(event.GetId());
	com->SwitchOn(dtr);
}

/*
 * ManualRelayOff
 * Function for the "Off" buttons
 * Correct port and pin are identified through the event ID
 */
void rc4Frame::ManualRelayOff(wxCommandEvent& event)
{
    bool dtr = isDtr(event.GetId());
    RelayControl* com = getRC(event.GetId());
	com->SwitchOff(dtr);
}

/*
 * OscillatorOn
 * Start an Oscillator
 * Correct port and pin are identified through the event ID
 */
void rc4Frame::OscillatorOn(wxCommandEvent& event)
{
    bool dtr = isDtr(event.GetId());
    RelayControl* com = getRC(event.GetId());
    wxSlider* slider = getSlider(event.GetId());
    oscillator* osc = new oscillator(com->hcom, slider->GetValue(), dtr);
    osc->Create();
    osc->Run();
    assignOscillator(osc, event.GetId());
}

/*
 * OscillatorOff
 * Stop an Oscillator
 * Correct oscillator is identified through the event ID
 */
void rc4Frame::OscillatorOff(wxCommandEvent& event)
{
    oscillator* osc = getOscillator(event.GetId());
    osc->Delete();
}

/*
 * ConfigureTT
 * Open the taskTimer configuration dialog
 */
void rc4Frame::ConfigureTT(wxCommandEvent& event)
{
    bool dtr = isDtr(event.GetId());
    RelayControl* com = getRC(event.GetId());
    wxCheckBox* box = getCheckbox(event.GetId());
	tasktimer* tt = new tasktimer(com->hcom, dtr);
	tasktimerDlg* ttdlg = new tasktimerDlg(NULL);
	ttdlg->addTaskTimer(tt);
	ttdlg->ShowModal();
	box->Enable(true);
	assignTasktimer(tt, event.GetId());
}

/*
 * ActivateTT
 * Activate the TaskTimer
 */
void rc4Frame::ActivateTT(wxCommandEvent& event)
{
    tasktimer* tt = getTasktimer(event.GetId());
    wxCheckBox* box = getCheckbox(event.GetId());
    tt->Create();
    tt->Run();
    box->Enable(false);
}

/*
 * ConfigureCountdown
 * Open the countdown configuration dialog
 */
void rc4Frame::ConfigureCountdown(wxCommandEvent& event)
{
    bool dtr = isDtr(event.GetId());
    RelayControl* com = getRC(event.GetId());
    wxGauge* gauge = getGauge(event.GetId());
    countdownDlg* cdDlg = new countdownDlg(NULL);
    cdDlg->SetCountdownParams(com->hcom, dtr, gauge);
    cdDlg->ShowModal();
}

/*
 * isDtr
 * true if DTR has to be used, false in case of rts
 */
bool rc4Frame::isDtr(int eventID)
{
    if(eventID > 1010 && eventID < 1050) return true;
    return false;
} 

/*
 * getRC
 * return a pointer to the correct RelaisControl object
 */
RelayControl* rc4Frame::getRC(int eventID)
{
    if(eventID > 1010 && eventID < 1020 || eventID > 1050 && eventID < 1060) return &com1;
    if(eventID > 1019 && eventID < 1029 || eventID > 1059 && eventID < 1069) return &com2;
    if(eventID > 1028 && eventID < 1038 || eventID > 1068 && eventID < 1078) return &com3;
    if(eventID > 1037 && eventID < 1047 || eventID > 1077 && eventID < 1087) return &com4;
    return NULL;
}

/*
 * getSlider
 * returns the correct slider pointer for clicked "Oscillator on" buttons
 */
wxSlider* rc4Frame::getSlider(int eventID)
{
    if(eventID == 1013) return WxSlider1;
    if(eventID == 1053) return WxSlider2;
    if(eventID == 1022) return WxSlider3;
    if(eventID == 1062) return WxSlider4;
    if(eventID == 1031) return WxSlider5;
    if(eventID == 1071) return WxSlider6;
    if(eventID == 1040) return WxSlider7;
    if(eventID == 1080) return WxSlider8;
    return NULL;
}

/*
 * assignOscillator
 * assign a created oscillator to one of the oscillator variables
 */
void rc4Frame::assignOscillator(oscillator* osc, int eventID)
{
    if(eventID == 1013) oscdtr1 = osc;
    if(eventID == 1053) oscrts1 = osc;
    if(eventID == 1022) oscdtr2 = osc;
    if(eventID == 1062) oscrts2 = osc;
    if(eventID == 1031) oscdtr3 = osc;
    if(eventID == 1071) oscrts3 = osc;
    if(eventID == 1040) oscdtr4 = osc;
    if(eventID == 1080) oscrts4 = osc;
} 

/*
 * getOscillator
 * returns the correct oscillator pointer for clicked oscillator off buttons
 */
oscillator* rc4Frame::getOscillator(int eventID)
{
    if(eventID == 1014) return oscdtr1;
    if(eventID == 1054) return oscrts1;
    if(eventID == 1023) return oscdtr2;
    if(eventID == 1063) return oscrts2;
    if(eventID == 1032) return oscdtr3;
    if(eventID == 1072) return oscrts3;
    if(eventID == 1041) return oscdtr4;
    if(eventID == 1081) return oscrts4;
    return NULL;
}

/*
 * assignTasktimer
 * assign a created tasktimer to one of the tasktimer variables
 */
void rc4Frame::assignTasktimer(tasktimer* tt, int eventID)
{
    if(eventID == 1016) ttdtr1 = tt;
    if(eventID == 1056) ttrts1 = tt;
    if(eventID == 1025) ttdtr2 = tt;
    if(eventID == 1065) ttrts2 = tt;
    if(eventID == 1034) ttdtr3 = tt;
    if(eventID == 1074) ttrts3 = tt;
    if(eventID == 1043) ttdtr4 = tt;
    if(eventID == 1083) ttrts4 = tt;
} 

/*
 * getTasktimer
 * returns the correct tasktimer pointer for clicked "enable" checkbox
 */
tasktimer* rc4Frame::getTasktimer(int eventID)
{
    if(eventID == 1018) return ttdtr1;
    if(eventID == 1058) return ttrts1;
    if(eventID == 1027) return ttdtr2;
    if(eventID == 1067) return ttrts2;
    if(eventID == 1036) return ttdtr3;
    if(eventID == 1076) return ttrts3;
    if(eventID == 1045) return ttdtr4;
    if(eventID == 1085) return ttrts4;
    return NULL;
}

/*
 * getCheckbox
 * returns the correct checkbox pointer for tasktimer operations
 */
wxCheckBox* rc4Frame::getCheckbox(int eventID)
{
    if(eventID == 1016 || eventID == 1018) return WxCheckBox1;
    if(eventID == 1056 || eventID == 1058) return WxCheckBox2;
    if(eventID == 1025 || eventID == 1027) return WxCheckBox3;
    if(eventID == 1065 || eventID == 1067) return WxCheckBox4;
    if(eventID == 1034 || eventID == 1036) return WxCheckBox5;
    if(eventID == 1074 || eventID == 1076) return WxCheckBox6;
    if(eventID == 1043 || eventID == 1045) return WxCheckBox7;
    if(eventID == 1083 || eventID == 1085) return WxCheckBox8;
    return NULL;
}

/*
 * getGauge
 * returns the correct gauge pointer for countdown operations
 */
wxGauge* rc4Frame::getGauge(int eventID)
{
    if(eventID == 1015) return WxGauge1;
    if(eventID == 1055) return WxGauge2;
    if(eventID == 1024) return WxGauge3;
    if(eventID == 1064) return WxGauge4;
    if(eventID == 1033) return WxGauge5;
    if(eventID == 1073) return WxGauge6;
    if(eventID == 1042) return WxGauge7;
    if(eventID == 1082) return WxGauge8;
    return NULL;
}

/*
 * OpenManual
 * Opens the manual in the system's standard browser
 */
void rc4Frame::OpenManual(wxCommandEvent& event)
{
    ShellExecute(0, "open", "rc4manual.html", "", "", 1);
}
