//-----------------------------------------------------------------------------
//
//   rc4Frame.h
//
//   Class definition of the class rc4Frame (Application Main Frame)
//
//    2007 by Bernd-Ludwig Wenning
//
//-----------------------------------------------------------------------------
//
//  This file is part of RC4.
//
//    RC4 is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    RCM is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with RC4; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//-----------------------------------------------------------------------------

#ifndef __rc4Frame_HPP_
#define __rc4Frame_HPP_

// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif

//Do not add custom headers.
//wx-dvcpp designer will remove them
////Header Include Start
#include <wx/stattext.h>
#include <wx/checkbox.h>
#include <wx/gauge.h>
#include <wx/slider.h>
#include <wx/button.h>
#include <wx/panel.h>
#include <wx/notebook.h>
////Header Include End

#include <wx/frame.h>

#include "oscillator.h"
#include "tasktimer.h"
#include "relctrl.h"

////Dialog Style Start
	#define THIS_DIALOG_STYLE wxCAPTION | wxSYSTEM_MENU | wxDIALOG_NO_PARENT | wxMINIMIZE_BOX |  wxCLOSE_BOX
////Dialog Style End

class rc4Frame : public wxFrame
{
private:
    DECLARE_EVENT_TABLE()
public:
    rc4Frame( wxWindow *parent, wxWindowID id = 1, const wxString &title = _T("rc4"),
        const wxPoint& pos = wxDefaultPosition,
        const wxSize& size = wxDefaultSize,
        long style = THIS_DIALOG_STYLE);
    virtual ~rc4Frame();
public:
  //Do not add custom Control Declarations here.
  //wx-devcpp will remove them. Try adding the custom code 
  //after the block.
  ////GUI Control Declaration Start
	wxButton *WxButton56;
	wxButton *WxButton55;
	wxButton *WxButton54;
	wxButton *WxButton53;
	wxButton *WxButton52;
	wxButton *WxButton51;
	wxButton *WxButton50;
	wxButton *WxButton49;
	wxButton *WxButton48;
	wxButton *WxButton47;
	wxButton *WxButton46;
	wxButton *WxButton45;
	wxButton *WxButton44;
	wxButton *WxButton43;
	wxCheckBox *WxCheckBox8;
	wxCheckBox *WxCheckBox7;
	wxGauge *WxGauge8;
	wxGauge *WxGauge7;
	wxSlider *WxSlider8;
	wxSlider *WxSlider7;
	wxStaticText *WxStaticText8;
	wxStaticText *WxStaticText7;
	wxPanel *WxNoteBookPage4;
	wxButton *WxButton42;
	wxButton *WxButton41;
	wxButton *WxButton40;
	wxButton *WxButton39;
	wxButton *WxButton38;
	wxButton *WxButton37;
	wxButton *WxButton36;
	wxButton *WxButton35;
	wxButton *WxButton34;
	wxButton *WxButton33;
	wxButton *WxButton32;
	wxButton *WxButton31;
	wxButton *WxButton30;
	wxButton *WxButton29;
	wxCheckBox *WxCheckBox6;
	wxCheckBox *WxCheckBox5;
	wxGauge *WxGauge6;
	wxGauge *WxGauge5;
	wxSlider *WxSlider6;
	wxSlider *WxSlider5;
	wxStaticText *WxStaticText6;
	wxStaticText *WxStaticText5;
	wxPanel *WxNoteBookPage3;
	wxButton *WxButton28;
	wxButton *WxButton27;
	wxButton *WxButton26;
	wxButton *WxButton25;
	wxButton *WxButton24;
	wxButton *WxButton23;
	wxButton *WxButton22;
	wxButton *WxButton21;
	wxButton *WxButton20;
	wxButton *WxButton19;
	wxButton *WxButton18;
	wxButton *WxButton17;
	wxButton *WxButton16;
	wxButton *WxButton15;
	wxCheckBox *WxCheckBox4;
	wxCheckBox *WxCheckBox3;
	wxGauge *WxGauge4;
	wxGauge *WxGauge3;
	wxSlider *WxSlider4;
	wxSlider *WxSlider3;
	wxStaticText *WxStaticText4;
	wxStaticText *WxStaticText3;
	wxPanel *WxNoteBookPage2;
	wxButton *WxButton14;
	wxButton *WxButton13;
	wxStaticText *WxStaticText2;
	wxStaticText *WxStaticText1;
	wxCheckBox *WxCheckBox2;
	wxCheckBox *WxCheckBox1;
	wxGauge *WxGauge2;
	wxGauge *WxGauge1;
	wxButton *WxButton12;
	wxButton *WxButton11;
	wxButton *WxButton10;
	wxButton *WxButton9;
	wxSlider *WxSlider2;
	wxSlider *WxSlider1;
	wxButton *WxButton8;
	wxButton *WxButton7;
	wxButton *WxButton6;
	wxButton *WxButton5;
	wxButton *WxButton4;
	wxButton *WxButton3;
	wxButton *WxButton2;
	wxButton *WxButton1;
	wxPanel *WxNoteBookPage1;
	wxNotebook *WxNotebook1;
  ////GUI Control Declaration End
public:
	//Note: if you receive any error with these enums, then you need to
    //change your old form code that are based on the #define control ids.
	//It may replace a numeric value in the enums names.
	enum {
////GUI Enum Control ID Start
ID_WXBUTTON56 = 1098 ,
ID_WXBUTTON55 = 1097 ,
ID_WXBUTTON54 = 1083 ,
ID_WXBUTTON53 = 1043 ,
ID_WXBUTTON52 = 1082 ,
ID_WXBUTTON51 = 1042 ,
ID_WXBUTTON50 = 1081 ,
ID_WXBUTTON49 = 1080 ,
ID_WXBUTTON48 = 1041 ,
ID_WXBUTTON47 = 1040 ,
ID_WXBUTTON46 = 1079 ,
ID_WXBUTTON45 = 1078 ,
ID_WXBUTTON44 = 1039 ,
ID_WXBUTTON43 = 1038 ,
ID_WXCHECKBOX8 = 1085 ,
ID_WXCHECKBOX7 = 1045 ,
ID_WXGAUGE8 = 1086 ,
ID_WXGAUGE7 = 1046 ,
ID_WXSLIDER8 = 1084 ,
ID_WXSLIDER7 = 1044 ,
ID_WXSTATICTEXT8 = 1106 ,
ID_WXSTATICTEXT7 = 1105 ,
ID_WXNOTEBOOKPAGE4 = 1005 ,
ID_WXBUTTON42 = 1096 ,
ID_WXBUTTON41 = 1095 ,
ID_WXBUTTON40 = 1074 ,
ID_WXBUTTON39 = 1034 ,
ID_WXBUTTON38 = 1073 ,
ID_WXBUTTON37 = 1033 ,
ID_WXBUTTON36 = 1072 ,
ID_WXBUTTON35 = 1071 ,
ID_WXBUTTON34 = 1032 ,
ID_WXBUTTON33 = 1031 ,
ID_WXBUTTON32 = 1070 ,
ID_WXBUTTON31 = 1069 ,
ID_WXBUTTON30 = 1030 ,
ID_WXBUTTON29 = 1029 ,
ID_WXCHECKBOX6 = 1076 ,
ID_WXCHECKBOX5 = 1036 ,
ID_WXGAUGE6 = 1077 ,
ID_WXGAUGE5 = 1037 ,
ID_WXSLIDER6 = 1075 ,
ID_WXSLIDER5 = 1035 ,
ID_WXSTATICTEXT6 = 1104 ,
ID_WXSTATICTEXT5 = 1103 ,
ID_WXNOTEBOOKPAGE3 = 1004 ,
ID_WXBUTTON28 = 1094 ,
ID_WXBUTTON27 = 1093 ,
ID_WXBUTTON26 = 1065 ,
ID_WXBUTTON25 = 1025 ,
ID_WXBUTTON24 = 1064 ,
ID_WXBUTTON23 = 1024 ,
ID_WXBUTTON22 = 1063 ,
ID_WXBUTTON21 = 1062 ,
ID_WXBUTTON20 = 1023 ,
ID_WXBUTTON19 = 1022 ,
ID_WXBUTTON18 = 1061 ,
ID_WXBUTTON17 = 1060 ,
ID_WXBUTTON16 = 1021 ,
ID_WXBUTTON15 = 1020 ,
ID_WXCHECKBOX4 = 1067 ,
ID_WXCHECKBOX3 = 1027 ,
ID_WXGAUGE4 = 1068 ,
ID_WXGAUGE3 = 1028 ,
ID_WXSLIDER4 = 1066 ,
ID_WXSLIDER3 = 1026 ,
ID_WXSTATICTEXT4 = 1102 ,
ID_WXSTATICTEXT3 = 1101 ,
ID_WXNOTEBOOKPAGE2 = 1003 ,
ID_WXBUTTON14 = 1092 ,
ID_WXBUTTON13 = 1091 ,
ID_WXSTATICTEXT2 = 1100 ,
ID_WXSTATICTEXT1 = 1099 ,
ID_WXCHECKBOX2 = 1058 ,
ID_WXCHECKBOX1 = 1018 ,
ID_WXGAUGE2 = 1059 ,
ID_WXGAUGE1 = 1019 ,
ID_WXBUTTON12 = 1056 ,
ID_WXBUTTON11 = 1016 ,
ID_WXBUTTON10 = 1055 ,
ID_WXBUTTON9 = 1015 ,
ID_WXSLIDER2 = 1057 ,
ID_WXSLIDER1 = 1017 ,
ID_WXBUTTON8 = 1054 ,
ID_WXBUTTON7 = 1053 ,
ID_WXBUTTON6 = 1014 ,
ID_WXBUTTON5 = 1013 ,
ID_WXBUTTON4 = 1052 ,
ID_WXBUTTON3 = 1051 ,
ID_WXBUTTON2 = 1012 ,
ID_WXBUTTON1 = 1011 ,
ID_WXNOTEBOOKPAGE1 = 1002 ,
ID_WXNOTEBOOK1 = 1001 ,
////GUI Enum Control ID End
   ID_DUMMY_VALUE_ //Dont Delete this DummyValue
   }; //End of Enum
public:
    void rc4FrameClose(wxCommandEvent& event);
    void CreateGUIControls(void);
	void ManualRelayOn(wxCommandEvent& event);
	void ManualRelayOff(wxCommandEvent& event);
	void OscillatorOn(wxCommandEvent& event);
	void OscillatorOff(wxCommandEvent& event);
	void ConfigureTT(wxCommandEvent& event);
	void ActivateTT(wxCommandEvent& event);
	void ConfigureCountdown(wxCommandEvent& event);
	void OpenManual(wxCommandEvent& event);
private:
    oscillator *oscdtr1;
    oscillator *oscrts1;
    oscillator *oscdtr2;
    oscillator *oscrts2;
    oscillator *oscdtr3;
    oscillator *oscrts3;
    oscillator *oscdtr4;
    oscillator *oscrts4;
    
    tasktimer *ttdtr1;
    tasktimer *ttrts1;
    tasktimer *ttdtr2;
    tasktimer *ttrts2;
    tasktimer *ttdtr3;
    tasktimer *ttrts3;
    tasktimer *ttdtr4;
    tasktimer *ttrts4;
    
    bool isDtr(int);
    RelayControl* getRC(int);
    wxSlider* getSlider(int);
    void assignOscillator(oscillator*, int);
    oscillator* getOscillator(int);
    void assignTasktimer(tasktimer*, int);
    tasktimer* getTasktimer(int);
    wxCheckBox* getCheckbox(int);
    wxGauge* getGauge(int);
};

#endif
 
 
 
 
