//-----------------------------------------------------------------------------
//
//   tasktimer.cpp
//
//   Implementation of the class tasktimer (Task timer thread)
//
//    2004-2007 by Bernd-Ludwig Wenning
//
//-----------------------------------------------------------------------------
//
//  This file is part of RC4.
//
//    RC4 is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    RCM is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with RC4; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//-----------------------------------------------------------------------------

#include "tasktimer.h"
#include "wx/datetime.h"

// Constructor
tasktimer::tasktimer(HANDLE h, bool dtr)
{
        rc.hcom=h;
        bdtr=dtr;
        tsks.t1h=0;
        tsks.t2h=0;
        tsks.t3h=0;
        tsks.t4h=0;
        tsks.t1m=0;
        tsks.t2m=0;
        tsks.t3m=0;
        tsks.t4m=0;
        tsks.t1on=false;
        tsks.t2on=false;
        tsks.t3on=false;
        tsks.t4on=false;
        t1f=false;
        t2f=false;
        t3f=false;
        t4f=false;
        completed=false;
}

// Schedule the tasks
void tasktimer::settimer(tasks tsk)
{
        tsks=tsk;
        t1f=false;
        t2f=false;
        t3f=false;
        t4f=false;
}

// Get task scheduling
tasks tasktimer::gettimer()
{
        return tsks;
}

// Start tasktimer thread
void *tasktimer::Entry()
{
     while((!TestDestroy())&&(!(t1f && t2f && t3f && t4f))){
         Sleep(2000); // Interval for checking if it is time to switch (milliseconds)
         wxDateTime Dt = wxDateTime::Now();
         unsigned short Dth = Dt.GetHour();
         unsigned short Dtm = Dt.GetMinute();
         if(!t1f){
             if((tsks.t1h==0)&&(tsks.t1m==0)){
                 t1f=true;
             }else if(((unsigned short)tsks.t1h==Dth)&&((unsigned short)tsks.t1m==Dtm)){
                 if(tsks.t1on){
                     rc.SwitchOn(bdtr);
                 }else{
                     rc.SwitchOff(bdtr);
                 }
                 t1f=true;
             }
         }
         if(!t2f){
             if((tsks.t2h==0)&&(tsks.t2m==0)){
                 t2f=true;
             }else if(((unsigned short)tsks.t2h==Dth)&&((unsigned short)tsks.t2m==Dtm)){
                 if(tsks.t2on){
                     rc.SwitchOn(bdtr);
                 }else{
                     rc.SwitchOff(bdtr);
                 }
                 t2f=true;
             }
         }
         if(!t3f){
             if((tsks.t3h==0)&&(tsks.t3m==0)){
                 t3f=true;
             }else if(((unsigned short)tsks.t3h==Dth)&&((unsigned short)tsks.t3m==Dtm)){
                 if(tsks.t3on){
                    rc.SwitchOn(bdtr);
                 }else{
                    rc.SwitchOff(bdtr);
                 }
                 t3f=true;
             }
         }
         if(!t4f){
             if((tsks.t4h==0)&&(tsks.t4m==0)){
                 t4f=true;
             }else if(((unsigned short)tsks.t4h==Dth)&&((unsigned short)tsks.t4m==Dtm)){
                 if(tsks.t4on){
                     rc.SwitchOn(bdtr);
                 }else{
                     rc.SwitchOff(bdtr);
                 }
                 t4f=true;
             }
         }
     }
     completed=true;
     
     rc.hcom=NULL;
     return NULL;
}
