//-----------------------------------------------------------------------------
//
//   tasktimer.h
//
//   Class definition of the class tasktimer (Task timer thread)
//    and definition of the tasks struct
//
//    2004-2007 by Bernd-Ludwig Wenning
//
//-----------------------------------------------------------------------------
//
//  This file is part of RC4.
//
//    RC4 is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//    RCM is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with RC4; if not, write to the Free Software
//    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//-----------------------------------------------------------------------------

#ifndef __tasktimer_h
#define __tasktimer_h

#include "wx/thread.h"
#include "relctrl.h"

struct tasks{
        int t1h, t1m, t2h, t2m, t3h, t3m, t4h, t4m;
        bool t1on, t2on, t3on, t4on;
};

class tasktimer : public wxThread
{
 private:
        tasks tsks;
        bool bdtr;
        bool t1f, t2f, t3f,t4f;
        RelayControl rc;
 public:
        tasktimer(HANDLE h, bool dtr);
        void settimer(tasks tsk);
        tasks gettimer();
        bool completed;
        virtual void* Entry();         
};

#endif
